// This file was generated by counterfeiter
package fake_process_tracker

import (
	"os/exec"
	"sync"
	"github.com/cloudfoundry-incubator/garden/warden"
	"github.com/cloudfoundry-incubator/warden-linux/linux_backend/process_tracker"
)

type FakeProcessTracker struct {
	RunStub        func(*exec.Cmd, warden.ProcessIO, *warden.TTYSpec) (warden.Process, error)
	runMutex       sync.RWMutex
	runArgsForCall []struct {
		arg1 *exec.Cmd
		arg2 warden.ProcessIO
		arg3 *warden.TTYSpec
	}
	runReturns struct {
		result1 warden.Process
		result2 error
	}
	AttachStub        func(uint32, warden.ProcessIO) (warden.Process, error)
	attachMutex       sync.RWMutex
	attachArgsForCall []struct {
		arg1 uint32
		arg2 warden.ProcessIO
	}
	attachReturns struct {
		result1 warden.Process
		result2 error
	}
	RestoreStub        func(processID uint32)
	restoreMutex       sync.RWMutex
	restoreArgsForCall []struct {
		processID uint32
	}
	ActiveProcessesStub        func() []warden.Process
	activeProcessesMutex       sync.RWMutex
	activeProcessesArgsForCall []struct{}
	activeProcessesReturns struct {
		result1 []warden.Process
	}
}

func (fake *FakeProcessTracker) Run(arg1 *exec.Cmd, arg2 warden.ProcessIO, arg3 *warden.TTYSpec) (warden.Process, error) {
	fake.runMutex.Lock()
	defer fake.runMutex.Unlock()
	fake.runArgsForCall = append(fake.runArgsForCall, struct {
		arg1 *exec.Cmd
		arg2 warden.ProcessIO
		arg3 *warden.TTYSpec
	}{arg1, arg2, arg3})
	if fake.RunStub != nil {
		return fake.RunStub(arg1, arg2, arg3)
	} else {
		return fake.runReturns.result1, fake.runReturns.result2
	}
}

func (fake *FakeProcessTracker) RunCallCount() int {
	fake.runMutex.RLock()
	defer fake.runMutex.RUnlock()
	return len(fake.runArgsForCall)
}

func (fake *FakeProcessTracker) RunArgsForCall(i int) (*exec.Cmd, warden.ProcessIO, *warden.TTYSpec) {
	fake.runMutex.RLock()
	defer fake.runMutex.RUnlock()
	return fake.runArgsForCall[i].arg1, fake.runArgsForCall[i].arg2, fake.runArgsForCall[i].arg3
}

func (fake *FakeProcessTracker) RunReturns(result1 warden.Process, result2 error) {
	fake.RunStub = nil
	fake.runReturns = struct {
		result1 warden.Process
		result2 error
	}{result1, result2}
}

func (fake *FakeProcessTracker) Attach(arg1 uint32, arg2 warden.ProcessIO) (warden.Process, error) {
	fake.attachMutex.Lock()
	defer fake.attachMutex.Unlock()
	fake.attachArgsForCall = append(fake.attachArgsForCall, struct {
		arg1 uint32
		arg2 warden.ProcessIO
	}{arg1, arg2})
	if fake.AttachStub != nil {
		return fake.AttachStub(arg1, arg2)
	} else {
		return fake.attachReturns.result1, fake.attachReturns.result2
	}
}

func (fake *FakeProcessTracker) AttachCallCount() int {
	fake.attachMutex.RLock()
	defer fake.attachMutex.RUnlock()
	return len(fake.attachArgsForCall)
}

func (fake *FakeProcessTracker) AttachArgsForCall(i int) (uint32, warden.ProcessIO) {
	fake.attachMutex.RLock()
	defer fake.attachMutex.RUnlock()
	return fake.attachArgsForCall[i].arg1, fake.attachArgsForCall[i].arg2
}

func (fake *FakeProcessTracker) AttachReturns(result1 warden.Process, result2 error) {
	fake.AttachStub = nil
	fake.attachReturns = struct {
		result1 warden.Process
		result2 error
	}{result1, result2}
}

func (fake *FakeProcessTracker) Restore(processID uint32) {
	fake.restoreMutex.Lock()
	defer fake.restoreMutex.Unlock()
	fake.restoreArgsForCall = append(fake.restoreArgsForCall, struct {
		processID uint32
	}{processID})
	if fake.RestoreStub != nil {
		fake.RestoreStub(processID)
	}
}

func (fake *FakeProcessTracker) RestoreCallCount() int {
	fake.restoreMutex.RLock()
	defer fake.restoreMutex.RUnlock()
	return len(fake.restoreArgsForCall)
}

func (fake *FakeProcessTracker) RestoreArgsForCall(i int) uint32 {
	fake.restoreMutex.RLock()
	defer fake.restoreMutex.RUnlock()
	return fake.restoreArgsForCall[i].processID
}

func (fake *FakeProcessTracker) ActiveProcesses() []warden.Process {
	fake.activeProcessesMutex.Lock()
	defer fake.activeProcessesMutex.Unlock()
	fake.activeProcessesArgsForCall = append(fake.activeProcessesArgsForCall, struct{}{})
	if fake.ActiveProcessesStub != nil {
		return fake.ActiveProcessesStub()
	} else {
		return fake.activeProcessesReturns.result1
	}
}

func (fake *FakeProcessTracker) ActiveProcessesCallCount() int {
	fake.activeProcessesMutex.RLock()
	defer fake.activeProcessesMutex.RUnlock()
	return len(fake.activeProcessesArgsForCall)
}

func (fake *FakeProcessTracker) ActiveProcessesReturns(result1 []warden.Process) {
	fake.ActiveProcessesStub = nil
	fake.activeProcessesReturns = struct {
		result1 []warden.Process
	}{result1}
}

var _ process_tracker.ProcessTracker = new(FakeProcessTracker)
